<script>
import {counterFactory} from '../stores/counterFactory'
export default {
  props: {
    name:String,
    counterInit:Number
  }, 
  data: () => {
    return {   
      mainStore:null   
    };
  },
  computed:{
    counter: function() {
      return  this.mainStore.count;  
    }
  },
  watch:{
    counter:function() {
      console.log("------counter changed",this.counter);
    }
  },
  methods: {
    startCounter() {
      setInterval(() => {
        this.mainStore.increment();     
      }, 1000);
    },
    showStatus() {
      console.log("-----status =",this.mainStore.name,this.mainStore.count)
    },
    increment2() {
      this.mainStore.count++;
    },
    showStore() {
      console.log("-------this.mainStore=",this.mainStore);
      let mainStore = counterFactory("anotherStore",200)();
      mainStore = counterFactory("anotherStore",200)();
      console.log("--------mainStore=",mainStore);
    }    
  },
  created() {
    console.log(`the component is now mounted.`)
    this.mainStore = counterFactory(this.name,this.counterInit)();
  }
};
</script>
<template>   
    <div>
      <button v-on:click="startCounter">Start {{ this.name }}</button>
      <h4>Counter = {{ this.mainStore.count}}</h4>   
      <h2>{{ this.counter }}</h2>
      <button v-on:click="showStore">showStore</button>  

    </div> 
</template>


